# Documentation

## Users

- [`brew` man-page (command documentation)](Manpage.md)
- [Homebrew Blog (news on major updates)](https://brew.sh/blog/)
- [Troubleshooting](Troubleshooting.md)
- [Installation](Installation.md)
- [Frequently Asked Questions](FAQ.md)
- [Common Issues](Common-Issues.md)
- [`brew` Shell Completion](Shell-Completion.md)
- [Homebrew on Linux](Homebrew-on-Linux.md)

- [Tips and Tricks](Tips-N'-Tricks.md)
- [Bottles (binary packages)](Bottles.md)
- [Taps (third-party repositories)](Taps.md)
- [Interesting Taps and Forks](Interesting-Taps-and-Forks.md)
- [Anonymous Aggregate User Behaviour Analytics](Analytics.md)

- [Querying `brew`](Querying-Brew.md)
- [C++ Standard Libraries](C++-Standard-Libraries.md)
- [MD5 and SHA-1 Deprecation](Checksum_Deprecation.md)
- [Custom GCC and Cross Compilers](Custom-GCC-and-cross-compilers.md)
- [External Commands](External-Commands.md)
- [Ruby Gems, Python Eggs and Perl Modules](Gems,-Eggs-and-Perl-Modules.md)
- [Python](Homebrew-and-Python.md)
- [How To Build Software Outside Homebrew With Homebrew `keg_only` dependencies](How-to-Build-Software-Outside-Homebrew-with-Homebrew-keg-only-Dependencies.md)
- [Xcode](Xcode.md)
- [Kickstarter Supporters](Kickstarter-Supporters.md)

- [Creating a Homebrew Issue](Creating-a-Homebrew-Issue.md)
- [Updating Software in Homebrew](Updating-Software-in-Homebrew.md)
- [Adding Software to Homebrew](Adding-Software-to-Homebrew.md)

## Contributors

- [How To Open A Pull Request (and get it merged)](How-To-Open-a-Homebrew-Pull-Request.md)
- [Formula Cookbook](Formula-Cookbook.md)
- [Acceptable Formulae](Acceptable-Formulae.md)
- [License Guidelines](License-Guidelines.md)
- [Formulae Versions](Versions.md)
- [Node for Formula Authors](Node-for-Formula-Authors.md)
- [Python for Formula Authors](Python-for-Formula-Authors.md)
- [Migrating A Formula To A Tap](Migrating-A-Formula-To-A-Tap.md)
- [Rename A Formula](Rename-A-Formula.md)
- [Building Against Non-Homebrew Dependencies](Building-Against-Non-Homebrew-Dependencies.md)
- [How To Create (And Maintain) A Tap](How-to-Create-and-Maintain-a-Tap.md)
- [Brew Test Bot](Brew-Test-Bot.md)
- [Prose Style Guidelines](Prose-Style-Guidelines.md)
- [Type Checking with Sorbet](Typechecking.md)

## Maintainers

- [New Maintainer Checklist](New-Maintainer-Checklist.md)
- [Maintainers: Avoiding Burnout](Maintainers-Avoiding-Burnout.md)
- [Maintainer Guidelines](Maintainer-Guidelines.md)
- [Homebrew/linuxbrew-core Maintainer Guide](Homebrew-linuxbrew-core-Maintainer-Guide.md)
- [Brew Test Bot For Maintainers](Brew-Test-Bot-For-Core-Contributors.md)
- [Common Issues for Maintainers](Common-Issues-for-Core-Contributors.md)
- [Releases](Releases.md)
- [Developer/Internal API Documentation](https://rubydoc.brew.sh)
- [Homebrew/homebrew-core merge checklist](Homebrew-homebrew-core-Merge-Checklist.md)

## Governance

- [Homebrew Governance](Homebrew-Governance.md)
